Motorcortex Robot Control is an implementation of higher-level API to control 
a robotic arm. This API allows to switch between control modes, to create 
and execute motion programs. 

Prerequisites
============

*motorcortex-cpp* https://git.vectioneer.com/vectioneer-core/motorcortex-cpp

See motorcortex-cpp [README](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/README.md)[INSTALL](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/INSTALL.md) for its prerequisites.

Installation
===========
These steps here are the minimum steps to get a default Debug build. Using CMake you can 
do many other things, including setting additional variables, setting up for static builds, 
or generation project or solution files for different development environments. Please 
check the CMake website for all the various options that CMake supports.

Linux
=====

See motorcortex-cpp [README](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/README.md) and [INSTALL](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/INSTALL.md)

*motorcortex-cpp-robot-control*

    mkdir build
    cd build
    cmake ..
    make
    sudo make install
    sudo ldconfig 

MacOS
=====

Windows
=======

The steps here are the minimum steps to get a default Debug build working from the command line and should be seen as a Quickstart guide. 

Similar settings will be required when using an IDE (e.g [VS Code](https://code.visualstudio.com/) or [VS Codium](https://vscodium.com/))

## Microsoft C++ Build Tools (Visual Studio) ##

### Installation ###

See motorcortex-cpp [README](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/README.md) and [INSTALL](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/INSTALL.md)

Extract motorcortex-robot-control-cpp to your workspace directory (e.g c:\workspace)

Run the following commands in the same development command prompt session used for motorcortex-cpp:

*motorcortex-robot-control-cpp*

    cd %ws%\motorcortex-robot-control-cpp
    md build
    cd build
    cmake .. -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_STANDARD_INCLUDE_DIRECTORIES=%id%\include -DCMAKE_INSTALL_PREFIX=%id%
    msbuild INSTALL.vcxproj

## MinGW-W64 ##

### Installation ###

See motorcortex-cpp [README](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/README.md) and [INSTALL](https://git.vectioneer.com/pub/motorcortex-cpp/-/blob/master/INSTALL.md)

Extract motorcortex-robot-control-cpp to your workspace directory (e.g c:\workspace)

Run the following commands in the same command prompt session used for motorcortex-cpp:

*motorcortex-robot-control-cpp*

    cd %ws%\motorcortex-robot-control-cpp
    md build
    cd build
    cmake .. -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_STANDARD_INCLUDE_DIRECTORIES=%mw%\include -DCMAKE_INSTALL_PREFIX=%mw% -G "MinGW Makefiles"
    mingw32-make install

Getting Started
===============
To get started look in the `test` folder for examples how to use this library.
