/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2019 VECTIONEER.
 */

#ifndef MOTORCORTEX_ROBOT_CONTROL_MESSAGE_TYPES_H
#define MOTORCORTEX_ROBOT_CONTROL_MESSAGE_TYPES_H

#include "cart_to_joint.h"
#include "joint_to_cart.h"
#include "motionSL.pb.h"
#include "motion_command.h"
#include <memory>
#include <nng/nng.h>
#include <vector>

namespace mcx_robot_control {

nng_msg* encodeMotionProgram(std::vector<std::shared_ptr<MotionCommand>> motion_commands, int id,
                             const std::string& name);

nng_msg* encodeJointToCart(const motion_spec_JointToCart& joint_to_cart);

nng_msg* encodeCartToJoint(const motion_spec_CartToJoint& cart_to_joint);

JointToCart decodeJointToCart(nng_msg* nng_msg);

CartToJoint decodeCartToJoint(nng_msg* nng_msg);

} // namespace mcx_robot_control

#endif // MOTORCORTEX_ROBOT_CONTROL_MESSAGE_TYPES_H
