/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2019 VECTIONEER.
 */

#ifndef MOTORCORTEX_ROBOT_CONTROL_MOVEC_H
#define MOTORCORTEX_ROBOT_CONTROL_MOVEC_H

#include "motion_command.h"
#include "waypoint.h"
#include <vector>

namespace mcx_robot_control {

class MoveC : public MotionCommand {
public:
  MoveC(size_t id, std::vector<Waypoint> waypoints, double angle, double velocity, double acceleration,
        double rotational_velocity, double rotational_acceleration, std::vector<double> ref_joint_coord_rad);

  virtual ~MoveC() = default;

  size_t encode(pb_ostream_t* stream) const final;

  [[nodiscard]] size_t size() const override;

  [[nodiscard]] motion_spec_MOTIONTYPE type() const override;

  [[nodiscard]] size_t id() const override;

private:
  size_t id_;
  std::vector<Waypoint> waypoints_;
  double angle_;
  double velocity_;
  double acceleration_;
  double rotational_velocity_;
  double rotational_acceleration_;
  std::vector<double> ref_joint_coord_rad_;
  size_t size_{};
};

} // namespace mcx_robot_control

#endif // MOTORCORTEX_ROBOT_CONTROL_MOVEC_H
