/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2019 VECTIONEER.
 */

#ifndef MOTORCORTEX_ROBOT_CONTROL_MOVEJ_H
#define MOTORCORTEX_ROBOT_CONTROL_MOVEJ_H

#include "motion_command.h"
#include "waypoint.h"
#include <vector>

namespace mcx_robot_control {

class MoveJ : public MotionCommand {
public:
  MoveJ(size_t id, std::vector<Waypoint> waypoints, double rotational_velocity, double rotational_acceleration);

  virtual ~MoveJ() = default;

  size_t encode(pb_ostream_t* stream) const final;

  [[nodiscard]] size_t size() const override;

  [[nodiscard]] motion_spec_MOTIONTYPE type() const override;

  [[nodiscard]] size_t id() const override;

private:
  static bool encodeWaypointsHook(pb_ostream_t* stream, const pb_field_t* field, void* const* arg);

  struct Container {
    size_t id{};
    std::vector<Waypoint> waypoints;
    double rotational_velocity{};
    double rotational_acceleration{};
  } container_;

  size_t size_{};
};

} // namespace mcx_robot_control

#endif // MOTORCORTEX_ROBOT_CONTROL_MOVEJ_H
