/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2019 VECTIONEER.
 */

#ifndef MOTORCORTEX_ROBOT_CONTROL_WAIT_H
#define MOTORCORTEX_ROBOT_CONTROL_WAIT_H

#include "motion_command.h"
#include <string>

namespace mcx_robot_control {

class Wait : public MotionCommand {
public:
  explicit Wait(size_t id, double time_s, std::string path, bool equal_to);

  virtual ~Wait() = default;

  size_t encode(pb_ostream_t* stream) const final;

  [[nodiscard]] size_t size() const override;

  [[nodiscard]] motion_spec_MOTIONTYPE type() const override;

  [[nodiscard]] size_t id() const override;

private:
  size_t id_;
  double time_s_;
  std::string path_;
  bool equal_to_;
  size_t size_;
};

} // namespace mcx_robot_control

#endif // MOTORCORTEX_ROBOT_CONTROL_WAIT_H
