/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2020 VECTIONEER.
 */

#include "paths.h"
#include "fstream"
#include "iostream"

using namespace mcx_robot_control;

Paths::Paths(nlohmann::json paths) : paths_(std::move(paths)) {}

void Paths::load(const std::string& filename) {
  std::ifstream f(filename);
  if (f.fail()) {
    throw(std::runtime_error(std::string("Failed open file: ").append(filename)));
  }
  nlohmann::json new_paths;
  f >> new_paths;
  paths_.merge_patch(new_paths);
}

void Paths::print() const { std::cout << paths_.dump(2) << std::endl; }

bool Paths::has(const std::string& parameter) const { return paths_.find(parameter) != paths_.end(); }

std::string Paths::get(const std::string& parameter) const { return paths_.at(parameter); }