/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2020 VECTIONEER.
 */

#ifndef MOTORCORTEX_CPP_PATHS_H
#define MOTORCORTEX_CPP_PATHS_H

#include "json.hpp"

namespace mcx_robot_control {

class Paths {
public:
  Paths() = default;

  explicit Paths(nlohmann::json path_json);

  void load(const std::string& filename);

  [[nodiscard]] bool has(const std::string& parameter) const;

  [[nodiscard]] std::string get(const std::string& parameter) const;

  void print() const;

private:
  nlohmann::json paths_{};
};

} // namespace mcx_robot_control

#endif // MOTORCORTEX_CPP_PATHS_H
