/*
 * Developer : Alexey Zakharov (alexey.zakharov@vectioneer.com)
 * All rights reserved. Copyright (c) 2019 VECTIONEER.
 */

#include "pose_ostream.h"

namespace mcx_robot_control {

std::ostream& operator<<(std::ostream& os, const motion_spec_CartPose6& cart_pose) {
  os << "Cartesian pose: ";
  if (cart_pose.coordinates_count == 0) {
    os << "[empty]";
  } else {
    os << "[";
    for (decltype(cart_pose.coordinates_count) i = 0; i < cart_pose.coordinates_count; i++) {
      os << cart_pose.coordinates[i] << (i < cart_pose.coordinates_count - 1 ? " " : "]");
    }
  }
  return os;
}

std::ostream& operator<<(std::ostream& os, const motion_spec_Twist& cart_twist) {
  os << "Cartesian twist: ";
  if (cart_twist.coordinates_count == 0) {
    os << "[empty]";
  } else {
    os << "[";
    for (decltype(cart_twist.coordinates_count) i = 0; i < cart_twist.coordinates_count; i++) {
      os << cart_twist.coordinates[i] << (i < cart_twist.coordinates_count - 1 ? " " : "]");
    }
  }
  return os;
}

std::ostream& operator<<(std::ostream& os, const motion_spec_JointPositions& joint_pose) {
  os << "Joint pose: ";
  if (joint_pose.coordinates_count == 0) {
    os << "[empty]";
  } else {
    os << "[";
    for (decltype(joint_pose.coordinates_count) i = 0; i < joint_pose.coordinates_count; i++) {
      os << joint_pose.coordinates[i] << (i < joint_pose.coordinates_count - 1 ? " " : "]");
    }
  }
  return os;
}

std::ostream& operator<<(std::ostream& os, const motion_spec_JointVelocities& joint_vel) {
  os << "Joint velocity: ";
  if (joint_vel.coordinates_count == 0) {
    os << "[empty]";
  } else {
    os << "[";
    for (decltype(joint_vel.coordinates_count) i = 0; i < joint_vel.coordinates_count; i++) {
      os << joint_vel.coordinates[i] << (i < joint_vel.coordinates_count - 1 ? " " : "]");
    }
  }
  return os;
}

} // namespace mcx_robot_control